clear all
close all
clc
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% generate data  %%%%%%%%%%%%%%%%
%%%%%
p=@(theta,a,b) 1./(1+exp(-a.*(theta-b)));
M=20;%%% number of peoples
theta_true=10*rand(1,M)
N=100; %%%% number of items 
%%%%%%%%%%%%%%%%%%%%%%%%%%%
a_true=0.2+(4-0.2)*rand(1,N);
%a_true=ones(1,N);
b_true=2+8*rand(1,N);
%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:M
    for j=1:N
        prob_matrix(i,j)=p(theta_true(i),a_true(j),b_true(j));
        u=rand(1,1);
        if u<=prob_matrix(i,j)
            Y(i,j)=1;
        else
            Y(i,j)=0;
        end
    end
end

%N=N1+N2;
%xi=[x1 x2];
%yi=[y1 y2];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Y
b_chain(:,1)=b_true';
a_chain(:,1)=a_true';
T=500;
%%%%%%%%%%%%% STARTING THE GIBBS SAMPLING %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for t=2:T+1
    t
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%%%%%%% SAMPLING ALL THETA'S fixing the others %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% All likelihood per person %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
theta=0:0.05:10;
clear logL
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:M
    for j=1:N
         for k=1:length(theta)     
              logL{i}(j,k)=Piece_LikeFun_IRT(b_chain(j,t-1),a_chain(j,t-1),theta(k),Y(i,j));  
         end
    end
    logLike_per_person(i,:)=sum(logL{i});
   %%% figure
   %%% plot(theta,exp(logLike_per_person(i,:)))  
    f(i,:)=exp(logLike_per_person(i,:));
   %%%%% posmax(i)=find(f(i,:)==max(f(i,:)));
    theta_chain(i,t)=sampling_from_a_piece_constant_pdf(f(i,:),theta,1);
    %sample(i,:)=sampling_from_a_piece_constant_pdf(f(i,:),theta,20000);
    %figure 
    %hist(sample(i,:),15)
    %pause
      
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%%%%%%% SAMPLING ALL b's fixing the other ones  %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
b=0:0.05:10;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 for j=1:N
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%     
        clear logL 
    for i=1:M
         for k=1:length(b)     
              logL(i,k)=Piece_LikeFun_IRT(b(k),a_chain(j,t-1),theta_chain(i,t),Y(i,j));  
         end
    end      
         logLike_part=sum(logL);
         %%%figure
         %%% plot(b,exp(logLike_part)) 
          g=exp(logLike_part);
         %%%%% posmax=find(g==max(g));
        %%%%%% b_approx=b(posmax)
          %%%%%%% b_true(j)
         b_chain(j,t)=sampling_from_a_piece_constant_pdf(g,b,1);
         
 end 

%%b_chain


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%%%%%%% SAMPLING ALL a's fixing the other ones  %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
a=0.1:0.05:10;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 for j=1:N
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
clear logL
%%%%%%%%%%%%%%%%%
       for i=1:M
         for k=1:length(a)     
              logL(i,k)=Piece_LikeFun_IRT(b_chain(j,t),a(k),theta_chain(i,t),Y(i,j));  
         end
       end
  %%%%%%%%%%%%%   
     logLike_part=sum(logL);
     %%% figure
     %%%% plot(a,exp(logLike_part)) 
        g=exp(logLike_part);
      %%%  posmax=find(g==max(g));
      %%%  a_approx=a(posmax)
      %%%%%a_true(j)  
      
     a_chain(j,t)=sampling_from_a_piece_constant_pdf(g,a,1);
 end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

%%%a_chain

end %%%% t loop of the Gibbs sampling
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
item=20;
plotmatrix([b_chain(item,:)' a_chain(item,:)']);

figure
item=100;
plotmatrix([b_chain(item,:)' a_chain(item,:)']);

figure 
person=4;
hist(theta_chain(person,:))

pause
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
Xemp_score=sum(Y,2);
plot(Xemp_score,'bo-')
title('Empiric Score')
xlabel('Persons')
set(gca,'Fontsize',15,'FontWeight','Bold')
pos_min_score=find(Xemp_score==min(Xemp_score));
pos_max_score=find(Xemp_score==max(Xemp_score));
figure
hist(theta_chain(pos_min_score,:),25)
title(' Person with the WORST EMP. SCORE ')
xlabel('Ability - Theta')
set(gca,'Fontsize',15,'FontWeight','Bold')
xlim([0 10])
figure
hist(theta_chain(pos_max_score,:),25)
xlabel('Ability - Theta')
title(' Person with the BEST EMP. SCORE ')
set(gca,'Fontsize',15,'FontWeight','Bold')
xlim([0 10])
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
RightAnswers_per_item=sum(Y);
plot(RightAnswers_per_item)
title('Right Answers')
xlabel('Items')
set(gca,'Fontsize',15,'FontWeight','Bold')
pos_min_RA=find(RightAnswers_per_item==min(RightAnswers_per_item));
pos_max_RA=find(RightAnswers_per_item==max(RightAnswers_per_item));
figure
hist(b_chain(pos_min_RA(1),:),20)
title(' ITEM with the SMALLEST number of Right Answers ')
xlabel('parameter DIFFICULTY - b ')
set(gca,'Fontsize',15,'FontWeight','Bold')
xlim([0 10])
figure
hist(a_chain(pos_min_RA(1),:),20)
title(' ITEM with the SMALLEST number of Right Answers ')
xlabel('parameter a (discrimination) ')
set(gca,'Fontsize',15,'FontWeight','Bold')
xlim([0 10])
figure
hist(b_chain(pos_max_RA(1),:),20)
title(' ITEM with the GREATEST number of Right Answers ')
xlabel('parameter DIFFICULTY - b ')
set(gca,'Fontsize',15,'FontWeight','Bold')
xlim([0 10])
figure
hist(a_chain(pos_max_RA(1),:),20)
title(' ITEM with the GREATEST number of Right Answers ')
xlabel('parameter a (discrimination) ')
set(gca,'Fontsize',15,'FontWeight','Bold')
xlim([0 10])

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
